# $Revision: 1.60 $, $Date: 2012/03/08 15:43:19 $
# TODO
# - update paths in manuals (create .in files and send upstream)
# - make /etc/pam.d independant of sysconfdir (configure-able option and send upstream)
# - syslog output (-s) writes two bytes of garbage to syslog instead of actual data:
#   Mar  3 09:30:01 ravenous CROND[2528]: 4ÿ
#
# Conditional build:
%bcond_without	inotify		# without inotify support
%if "%{pld_release}" == "ac"
%bcond_with		selinux		# without SELinux support
%bcond_with		audit		# without audit support
%else
%bcond_without	selinux		# without SELinux support
%bcond_without	audit		# without audit support
%endif

Summary:	Cron daemon for executing programs at set times
Name:		cronie
Version:	1.4.8
Release:	16
License:	MIT and BSD and GPL v2
Group:		Daemons
Source0:	https://fedorahosted.org/releases/c/r/cronie/%{name}-%{version}.tar.gz
# Source0-md5:	9b1d2ce6db8d1883e06635f437170657
Source1:	%{name}.init
Source2:	cron.logrotate
Source3:	cron.sysconfig
Source4:	%{name}.crontab
Source5:	%{name}.pam
Source6:	%{name}.upstart
Source7:	crond.service
Patch0:		inotify-nosys.patch
Patch1:		%{name}-nosyscrontab.patch
Patch2:		sendmail-path.patch
Patch3:		cronie-1.4.8-inotify-fix.patch
URL:		https://fedorahosted.org/cronie/
%{?with_audit:BuildRequires:	audit-libs-devel}
BuildRequires:	autoconf
BuildRequires:	automake
%{?with_selinux:BuildRequires:	libselinux-devel}
BuildRequires:	pam-devel
BuildRequires:	rpm >= 4.4.9-56
BuildRequires:	rpmbuild(macros) >= 1.626
Requires(post):	fileutils
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires:	/bin/run-parts
Requires:	psmisc >= 20.1
Requires:	rc-scripts >= 0.4.3.0
Requires:	systemd-units >= 37-0.10
%{?with_inotify:Requires:	uname(release) >= 2.6.13}
Provides:	crondaemon
Provides:	crontabs = 1.7
Provides:	group(crontab)
%if "%{pld_release}" == "th"
Provides:	vixie-cron = 4.3-1
%endif
Obsoletes:	crondaemon
Obsoletes:	cronie-systemd
Obsoletes:	crontabs
%if "%{pld_release}" == "th"
Obsoletes:	vixie-cron < 4.3-1
%endif
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Cronie contains the standard UNIX daemon crond that runs specified
programs at scheduled times and related tools. It is based on the
original cron and has security and configuration enhancements like the
ability to use pam and SELinux.

%package anacron
Summary:	Utility for running regular jobs
Group:		Base
Provides:	anacron = 2.4
Obsoletes:	anacron <= 2.3

%description anacron
Anacron becames part of cronie. Anacron is used only for running
regular jobs. The default settings execute regular jobs by anacron,
however this could be overloaded in settings.

%package upstart
Summary:	Upstart job description for Cronie
Summary(pl.UTF-8):	Opis zadania Upstart dla Cronie
Group:		Daemons
Requires:	%{name} = %{version}-%{release}
Requires:	upstart >= 0.6

%description upstart
Upstart job description for Cronie.

%description upstart -l pl.UTF-8
Opis zadania Upstart dla Cronie.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%build
%{__aclocal}
%{__autoconf}
%{__autoheader}
%{__automake}
%configure \
	SYSCRONTAB=/etc/crontab \
	SYS_CROND_DIR=/etc/cron.d \
	--sysconfdir=/etc/cron \
	--with-pam \
	--with%{!?with_selinux:out}-selinux \
	--with%{!?with_audit:out}-audit \
	--with%{!?with_inotify:out}-inotify \
%if "%{cc_version}" >= "3.4"
	--enable-pie \
%endif
	--enable-relro \
	--enable-anacron

%{__make}

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/var/{log,spool/{ana,}cron},%{_mandir},%{systemdunitdir}}\
	$RPM_BUILD_ROOT/etc/{rc.d/init.d,logrotate.d,sysconfig,init} \
	$RPM_BUILD_ROOT%{_sysconfdir}/{cron,cron.{d,hourly,daily,weekly,monthly},pam.d}

%{__make} install \
	pamdir=/etc/pam.d \
	DESTDIR=$RPM_BUILD_ROOT

install -p %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/crond
cp -a contrib/0anacron $RPM_BUILD_ROOT/etc/cron.hourly/0anacron
cp -a %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/cron
cp -a %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/cron
cp -a %{SOURCE4} $RPM_BUILD_ROOT/etc/cron.d/crontab
cp -a %{SOURCE5} $RPM_BUILD_ROOT/etc/pam.d/crond
cp -a %{SOURCE6} $RPM_BUILD_ROOT/etc/init/crond.conf
cp -a %{SOURCE7} $RPM_BUILD_ROOT%{systemdunitdir}/crond.service

touch $RPM_BUILD_ROOT/var/log/cron

cat > $RPM_BUILD_ROOT%{_sysconfdir}/cron/cron.allow << 'EOF'
# cron.allow	This file describes the names of the users which are
#		allowed to use the local cron daemon
root
EOF

cat > $RPM_BUILD_ROOT%{_sysconfdir}/cron/cron.deny << 'EOF'
# cron.deny	This file describes the names of the users which are
#		NOT allowed to use the local cron daemon
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 117 -r -f crontab

%post
if [ ! -f /var/log/cron ]; then
	install -m 660 -g crontab /dev/null /var/log/cron
fi
/sbin/chkconfig --add crond
%service crond restart "Cron Daemon"
%systemd_post crond.service

%preun
if [ "$1" = "0" ]; then
	%service crond stop
	/sbin/chkconfig --del crond
fi
%systemd_preun crond.service

%postun
if [ "$1" = "0" ]; then
	%groupremove crontab
fi
%systemd_reload

%triggerpostun -- cronie < 1.4.8-13
if [ -f /etc/sysconfig/cron ]; then
	. /etc/sysconfig/cron
	__CROND_ARGS=
	[ "$CROND_SYSLOG_RESULT" = "yes" ] && __CROND_ARGS="-s"
	[ -n "$CROND_MAIL_PROG" ] && __CROND_ARGS="$__CROND_ARGS -m $CROND_MAIL_PROG"
	if [ -n "$__CROND_ARGS" ]; then
		%{__cp} -f /etc/sysconfig/cron{,.rpmsave}
		echo >>/etc/sysconfig/cron
		echo "# Added by rpm trigger" >>/etc/sysconfig/cron
		echo "CROND_ARGS=\"$CROND_ARGS $__CROND_ARGS\"" >>/etc/sysconfig/cron
	fi
fi
%systemd_trigger crond.service

%triggerun -- hc-cron,fcron,vixie-cron
# Prevent preun from crond from working
chmod a-x /etc/rc.d/init.d/crond

%triggerpostun -- hc-cron,fcron,vixie-cron
# Restore what triggerun removed
chmod 754 /etc/rc.d/init.d/crond
# reinstall crond init.d links, which could be different
/sbin/chkconfig --del crond
/sbin/chkconfig --add crond

%post upstart
%upstart_post crond

%postun upstart
%upstart_postun crond

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog README
%attr(750,root,crontab) %dir %{_sysconfdir}/cron*
%attr(640,root,crontab) %config(noreplace,missingok) /etc/cron.d/crontab
%attr(640,root,crontab) %config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/cron/cron.allow
%attr(640,root,crontab) %config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/cron/cron.deny
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/cron
%config(noreplace) %verify(not md5 mtime size) /etc/pam.d/crond
%attr(754,root,root) /etc/rc.d/init.d/crond
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/logrotate.d/cron
%{systemdunitdir}/crond.service
%attr(755,root,root) %{_sbindir}/crond
%attr(2755,root,crontab) %{_bindir}/crontab

%{_mandir}/man8/crond.8*
%{_mandir}/man8/cron.8*
%{_mandir}/man5/crontab.5*
%{_mandir}/man1/crontab.1*

%attr(1730,root,crontab) /var/spool/cron
%attr(660,root,crontab) %ghost /var/log/cron

%files anacron
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/anacron
%attr(755,root,root) %{_sysconfdir}/cron.hourly/0anacron
%{_mandir}/man5/anacrontab.5*
%{_mandir}/man8/anacron.8*

%attr(1730,root,crontab) /var/spool/anacron

%if "%{pld_release}" != "ti"
%files upstart
%defattr(644,root,root,755)
%config(noreplace) %verify(not md5 mtime size) /etc/init/crond.conf
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: cronie.spec,v $
Revision 1.60  2012/03/08 15:43:19  glen
- -fPIE in gcc 3.4

Revision 1.59  2012/03/02 12:35:26  arekm
- rel 16; don't leak fds

Revision 1.58  2012/02/11 20:58:16  baggins
- rel 15
- use __cp macro in trigger, cp may be an alias

Revision 1.57  2012/02/08 13:14:44  baggins
- rel 14
- keep service name same as SysV to avoid dead daemon after upgrade to systemd

Revision 1.56  2012/02/08 11:37:58  baggins
- rel 13
- don't exit from trigger

Revision 1.55  2012/02/06 16:30:21  baggins
- rel 12
- hide obsolete options from sysconfig

Revision 1.54  2012/02/06 16:26:57  baggins
- rel 11
- that's how you do it, blues

Revision 1.53  2012/02/05 17:34:00  baggins
- rel 10
- added O:-systemd

Revision 1.52  2012/02/05 16:14:41  baggins
- rel 9
- merge systemd stuff into main package

Revision 1.51  2012/02/04 22:26:15  blues
- macro

Revision 1.50  2011/12/04 17:28:25  wiget
- use newer systemd macros

Revision 1.49  2011/12/04 13:27:28  wiget
- rel. 7, rebuild with fixed systemd macros

Revision 1.48  2011/12/04 01:29:32  wiget
- rel. 6

Revision 1.47  2011/12/04 01:27:33  blues
- typo

Revision 1.46  2011/12/04 01:16:53  wiget
- %*post scripts for systemd
- rel. 5

Revision 1.45  2011/12/02 20:43:45  cactus
- rel 4; systemd service

Revision 1.44  2011/10/31 09:50:44  glen
- obsoleted should not obsolete version we provide

Revision 1.43  2011/10/31 08:38:21  glen
- last vixie cron release was in pld vixie-cron-0:4.1-23 (note no epoch)
  fix upgrade path via obsoleted.spec

Revision 1.42  2011/09/25 10:40:53  glen
- update upstart deps

Revision 1.41  2011/07/02 09:57:06  adamg
- updated to 1.4.8

Revision 1.40  2011/03/22 11:27:10  glen
- up to 1.4.7, --enable-pie, --enable-relro

Revision 1.39  2010/12/14 20:59:00  glen
- pam trigger in pam package, where it is more natural; rel 4

Revision 1.38  2010/12/05 13:33:50  hawk
- Titanium will not support upstart

Revision 1.37  2010/11/02 10:14:35  arekm
- mention why is restarted

Revision 1.36  2010/10/31 22:18:08  glen
- restart crond when pam is upgraded; rel 2

Revision 1.35  2010/10/25 11:40:37  glen
- up to 1.4.6

Revision 1.34  2010/05/26 06:33:29  jajcus
- missing 'start on' and 'stop on' added to the upstart job
- Release: 6

Revision 1.33  2010/05/24 14:57:35  jajcus
- upstart support added
- Release: 5

Revision 1.32  2010/05/10 15:44:30  hawk
- release 4

Revision 1.31  2010/04/18 15:04:49  glen
- use install(1) to do all in once, but it's racy?

Revision 1.30  2010/03/16 14:28:27  megabajt
- added CVE reference in rev 1.26

Revision 1.29  2010/03/03 13:02:42  glen
- syslog output broken

Revision 1.28  2010/03/02 21:27:57  glen
- add support for -m and -s options via sysconfig; rel 3

Revision 1.27  2010/02/22 10:51:30  glen
- release 2

Revision 1.26  2010/02/22 10:51:16  glen
- up to 1.4.4 [fixes CVE-2010-0424]

Revision 1.25  2010/01/04 13:07:13  glen
- fix migration triggers from other crontabs
- update todo
- rel 2

Revision 1.24  2009/11/17 10:02:09  glen
- status --pidfile dep in initscript

Revision 1.23  2009/11/17 08:51:04  glen
- up to 1.4.3

Revision 1.22  2009/11/17 06:15:56  glen
- use /usr/lib/sendmail for sendmail path; rel 2

Revision 1.21  2009/10/28 18:15:19  glen
- todo toughts

Revision 1.20  2009/10/28 18:06:43  glen
- update to 1.4.2

Revision 1.19  2009/09/09 13:03:39  arekm
- rel 7; no /etc/crontab processing

Revision 1.18  2009/08/27 07:06:53  arekm
- rel 6; leave syscrontab as /etc/crontab. /etc/cron.d/crontab will be still
  processed by cron.d/ dir rule and we don't want for it to be processed twice.

Revision 1.17  2009/08/18 10:54:19  arekm
- release 5

Revision 1.16  2009/08/18 09:22:48  arekm
- release 4

Revision 1.15  2009/08/13 16:11:13  glen
- few todo

Revision 1.14  2009/08/13 15:53:00  glen
- fix pam dir on install, disable selinux,audit on ac (need more work)

Revision 1.13  2009/08/13 11:34:20  hawk
- don't provide/obsolete vixie-cron on Titanium

Revision 1.12  2009/08/13 10:59:00  glen
- add inotify interface if it's missing in glibc but kernel has it

Revision 1.11  2009/08/13 10:43:58  glen
- audit bcond, regen automake

Revision 1.10  2009/08/13 10:31:39  glen
- inotify bcond and glibc interface dep

Revision 1.9  2009/08/12 08:27:21  glen
- bcond fix

Revision 1.8  2009/08/11 21:08:27  arekm
- rel 2; add /var/spool/anacron

Revision 1.7  2009/08/11 20:59:08  arekm
- upload via dropin

Revision 1.6  2009/08/11 20:53:30  arekm
- rel 1; works for me

Revision 1.5  2009/08/11 20:49:31  arekm
- sysconf path fixed

Revision 1.4  2009/08/11 20:23:42  arekm
- add vixie-cron trigger

Revision 1.3  2009/08/11 20:18:54  arekm
- supported way is to set via configure visible vars

Revision 1.2  2009/08/11 20:07:52  arekm
- pldize paths

Revision 1.1  2009/08/11 20:04:59  arekm
- initial
